=== added file 'src/com/goldencode/p2j/ui/CalendarConfig.java'
--- src/com/goldencode/p2j/ui/CalendarConfig.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/CalendarConfig.java	2020-02-25 12:56:55 +0000
@@ -0,0 +1,574 @@
+/*
+** Module   : CalendarConfig.java
+** Abstract : The calendar widget configuration settings.
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description-----------------------------------
+** 001 SBI 20200114 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.ui;
+
+import java.io.*;
+import java.text.*;
+import java.time.format.*;
+import java.time.temporal.*;
+import java.util.*;
+
+import com.goldencode.p2j.util.*;
+
+
+
+/**
+ * Represents the calendar settings.
+ */
+public class CalendarConfig
+extends WidgetConfigExt
+{
+   /**
+    * Displays the date in long format. The default format string for this style is defined by
+    * the current locale settings, which produces output like "Saturday, February 1, 2020". 
+    */
+   public static final int DTS_LONGDATEFORMAT  = 0;
+   
+   /**
+    * Displays the date in short format. The default format string for this style is defined by
+    * the current locale settings, which produces output like "02/01/20". 
+    */
+   public static final int DTS_SHORTDATEFORMAT = 1;
+   
+   /**
+    * Displays the time. The default format string for this style is defined by the current locale
+    * settings, which produces output like "10:29:00 AM". 
+    */
+   public static final int DTS_TIMEFORMAT      = 2;
+   
+   /**
+    * Displays date and time using the format string specified in the 'CustomFormat' property.
+    */
+   public static final int DTS_CUSTOMFORMAT    = 3;
+   
+   /**
+    * The format style constant, it can be one of DTS_LONGDATEFORMAT, DTS_SHORTDATEFORMAT,
+    * DTS_TIMEFORMAT, DTS_CUSTOMFORMAT.
+    */
+   public int formatStyle;
+   
+   /** Holds the current date time format.*/
+   public String customFormat;
+   
+   /** Holds the current date or time value as a string value in the ISO-8601 calendar system. */
+   public String dateTimeValue;
+   
+   /** Holds the day number from 1 to 31. */
+   public int day;
+   
+   /** Holds the month number from 1 to 12. */
+   public int month;
+   
+   /** Holds the year number. */
+   public int year;
+   
+   /** Holds the day of week number from 0 to 6 */
+   public int dayOfWeek;
+   
+   /** Holds the hour number from 0 to 23. */
+   public int hour;
+   
+   /** Holds the minute number from 0 to 59. */
+   public int minute;
+   
+   /** Holds the second number from 0 to 59. */
+   public int second;
+   
+   /** Holds the latest possible date */
+   public date latestDate;
+   
+   /** Holds the earliest possible date */
+   public date earliestDate;
+   
+   /** The background color for the dropdown calendar given by the BGR encoding */
+   public int bodyBackgroundColor;
+   
+   /** The foreground color for the dropdown calendar given by the BGR encoding */
+   public int bodyForegroundColor;
+   
+   /**
+    * The background color for the title portion of the dropdown calendar
+    * given by the BGR encoding.
+    */
+   public int titleBackgroundColor;
+   
+   /**
+    * The foreground color for the title portion of the dropdown calendar
+    * given by the BGR encoding.
+    */
+   public int titleForegroundColor;
+   
+   /**
+    * The foreground color for the previous and following months of
+    * the dropdown calendar given by the BGR encoding
+    */
+   public int trailingForegroundColor;
+   
+   /** True if a checkbox to the left of the date must be displayed, otherwise false */
+   public boolean checkBox;
+   
+   /** Its value indicates if the up and down buttons are used to modify dates or not*/
+   public boolean upDown;
+   
+   /** Represents an index of the selected field of the date/time content */
+   public int selectedFieldIndex;
+   
+   /**
+    * Converts the control format style to the pair of date and time legacy format style used
+    * by java time api. If for the date format style element or for the time format style element
+    * there doesn't exist a such correspondent legacy format style used by java time api,
+    * then this element holds a null value.
+    * 
+    * @param    formatStyle
+    *           The format style constant provided for the calendar widget
+    * 
+    * @return   The array of the date and time legacy format styles used by java time api.
+    */
+   public static final FormatStyle[] toDateTimeStyles(int formatStyle)
+   {
+      FormatStyle[] legacyStyles = new FormatStyle[2];
+      
+      switch(formatStyle)
+      {
+         case DTS_LONGDATEFORMAT:
+            legacyStyles[0] = FormatStyle.FULL;
+            break;
+         case DTS_SHORTDATEFORMAT:
+            legacyStyles[0] = FormatStyle.SHORT;
+            break;
+         case DTS_TIMEFORMAT:
+            legacyStyles[1] = FormatStyle.SHORT;
+            break;
+         default:
+      }
+      
+      return legacyStyles;
+   }
+   
+   /**
+    * Tests if the given format style is one of the predefined localized system date and time
+    * formats to display dates as full or short form styles or to display times in a short form.
+    *  
+    * @param    formatStyle
+    *           The given format style
+    * 
+    * @return   true if the given format style is one of the predefined formats, otherwise false.
+    */
+   public static final boolean isLocalizedFormat(int formatStyle)
+   {
+      return formatStyle != DTS_CUSTOMFORMAT;
+   }
+   
+   /**
+    * The default constructor.
+    */
+   public CalendarConfig()
+   {
+      selectedFieldIndex = 0;
+   }
+   
+   /**
+    * Creates this instance using the given identifier.
+    * 
+    * @param    id
+    *           The widget identifier
+    */
+   public CalendarConfig(int id)
+   {
+      super(id);
+      selectedFieldIndex = 0;
+   }
+   
+   /**
+    * Creates this instance using the given identifier.
+    * 
+    * @param    id
+    *           The widget identifier
+    */
+   public CalendarConfig(WidgetId id)
+   {
+      super(id);
+      selectedFieldIndex = 0;
+   }
+   
+   /**
+    * Set new values from the provided configuration instance.
+    * 
+    * @param    config
+    *           The instance from which to take values.
+    */
+   @Override
+   public void applyConfig(WidgetConfig config)
+   {
+      super.applyConfig(config);
+      
+      CalendarConfig cfg = (CalendarConfig) config;
+      
+      formatStyle   = cfg.formatStyle; 
+      customFormat  = cfg.customFormat;
+      dateTimeValue = cfg.dateTimeValue;
+      
+      day = cfg.day;
+      month = cfg.month;
+      year = cfg.year;
+      
+      dayOfWeek = cfg.dayOfWeek;
+      
+      hour = cfg.hour;
+      minute = cfg.minute;
+      second = cfg.second;
+      
+      latestDate   = cfg.latestDate;
+      earliestDate = cfg.earliestDate;
+      
+      bodyBackgroundColor = cfg.bodyBackgroundColor;
+      bodyForegroundColor = cfg.bodyForegroundColor;
+      titleBackgroundColor = cfg.titleBackgroundColor;
+      titleForegroundColor = cfg.titleForegroundColor;
+      trailingForegroundColor = cfg.trailingForegroundColor;
+      
+      checkBox = cfg.checkBox;
+      upDown   = cfg.upDown;
+      
+      selectedFieldIndex = cfg.selectedFieldIndex;
+   }
+   
+   /**
+    * Replacement for the default object reading method. The latest
+    * state is read from the input source.  The parent's state is
+    * read first.
+    * 
+    * @param    in
+    *           The input source from which fields will be restored.
+    *
+    * @throws   IOException
+    *           In case of I/O errors.
+    * @throws   ClassNotFoundException
+    *           If payload can't be instantiated.
+    */
+   @Override
+   public void readExternal(ObjectInput in)
+   throws IOException,
+          ClassNotFoundException
+   {
+      super.readExternal(in);
+      
+      formatStyle   = in.readInt();
+      customFormat  = (String) in.readObject();
+      dateTimeValue = (String) in.readObject();
+      
+      day = in.readInt();
+      month = in.readInt();
+      year = in.readInt();
+      
+      dayOfWeek = in.readInt();
+      
+      hour = in.readInt();
+      minute = in.readInt();
+      second = in.readInt();
+      
+      latestDate   = (date) in.readObject();
+      earliestDate = (date) in.readObject();
+      
+      bodyBackgroundColor = in.readInt();
+      bodyForegroundColor = in.readInt();
+      titleBackgroundColor = in.readInt();
+      titleForegroundColor = in.readInt();
+      trailingForegroundColor = in.readInt();
+      
+      checkBox = in.readBoolean();
+      upDown = in.readBoolean();
+      
+      selectedFieldIndex = in.readInt();
+   }
+
+   /**
+    * Replacement for the default object writing method. The latest
+    * state is written to the output destination.  The parent's state is
+    * written first.
+    * 
+    * @param    out
+    *           The output destination to which fields will be saved.
+    *
+    * @throws   IOException
+    *           In case of I/O errors.
+    */
+   @Override
+   public void writeExternal(ObjectOutput out)
+   throws IOException
+   {
+      super.writeExternal(out);
+      
+      out.writeInt(formatStyle);
+      out.writeObject(customFormat);
+      out.writeObject(dateTimeValue);
+      
+      out.writeInt(day);
+      out.writeInt(month);
+      out.writeInt(year);
+      
+      out.writeInt(dayOfWeek);
+      
+      out.writeInt(hour);
+      out.writeInt(minute);
+      out.writeInt(second);
+      
+      out.writeObject(latestDate);
+      out.writeObject(earliestDate);
+      
+      out.writeInt(bodyBackgroundColor);
+      out.writeInt(bodyForegroundColor);
+      out.writeInt(titleBackgroundColor);
+      out.writeInt(titleForegroundColor);
+      out.writeInt(trailingForegroundColor);
+      
+      out.writeBoolean(checkBox);
+      out.writeBoolean(upDown);
+      
+      out.writeInt(selectedFieldIndex);
+   }
+   
+   /**
+    * Adapts DateFormat to ChronoField and resolves positions of date and time fields within
+    * date and time patterns.
+    */
+   public static class DateFormatFieldsAdapter
+   {
+      /** Maps DateFormat fields to ChronoField enums. */
+      private static final Map<Integer, ChronoField> DATA_CHRONO_FIELDS;
+      
+      static
+      {
+         HashMap<Integer, ChronoField> temp = new HashMap<>(DateTimeField.values().length);
+         
+         for (DateTimeField dateTimeField : DateTimeField.values())
+         {
+            temp.put(dateTimeField.getDateFormat(), dateTimeField.getChronoField());
+         }
+         
+         DATA_CHRONO_FIELDS = Collections.unmodifiableMap(temp);
+      }
+      
+      /**
+       * Returns positions of date and time fields used by the given date time pattern string.
+       * 
+       * @param    dateTimePattern
+       *           The given date time pattern string
+       * @param    date
+       *           The given date to display
+       * 
+       * @return   The ordered array of positions of date and time fields
+       */
+      public static FieldPosition[] getDateTimeFieldPositions(String dateTimePattern, Date date)
+      {
+         SimpleDateFormat positionParser = new SimpleDateFormat(dateTimePattern);
+         
+         String displayedDate = positionParser.format(date);
+         
+         DateTimeFormatterBuilder builder = new DateTimeFormatterBuilder();
+         builder.appendPattern(dateTimePattern);
+         DateTimeFormatter formatter = builder.toFormatter();
+         TemporalAccessor accessor = formatter.parse(displayedDate);
+
+         ArrayList<FieldPosition> positions = new ArrayList<FieldPosition>(DATA_CHRONO_FIELDS.size());
+         
+         StringBuffer buffer = new StringBuffer();
+         
+         for (DateTimeField dateTimeField : DateTimeField.values())
+         {
+            if (accessor.isSupported(dateTimeField.getChronoField()))
+            {
+               FieldPosition fieldPosition = new FieldPosition(dateTimeField.getDateFormat());
+               
+               positionParser.format(date, buffer, fieldPosition);
+               
+               if (fieldPosition.getBeginIndex() != fieldPosition.getEndIndex())
+               {
+                  positions.add(fieldPosition);
+               }
+               
+               buffer.setLength(0);
+            }
+         }
+         
+         positions.sort(Comparator.<FieldPosition>comparingInt(FieldPosition::getBeginIndex));
+         
+         return positions.toArray(new FieldPosition[positions.size()]);
+      }
+      
+      /**
+       * Maps the DataFormat field to ChronoField.
+       * 
+       * @param    dataField
+       *           The given DataFormat field
+       * 
+       * @return   The target ChronoField
+       */
+      public static ChronoField getChronoField(int dataField)
+      {
+         return DATA_CHRONO_FIELDS.get(Integer.valueOf(dataField));
+      }
+      
+      /**
+       * Defines date time fields that maps DateFormat date/time constants to ChronoField members.
+       */
+      public enum DateTimeField
+      {
+         /**
+          * Represents the day of month field.
+          */
+         DATE_FIELD(DateFormat.DATE_FIELD, ChronoField.DAY_OF_MONTH),
+         
+         /**
+          * Represents the month field.
+          */
+         MONTH_FIELD(DateFormat.MONTH_FIELD, ChronoField.MONTH_OF_YEAR),
+         
+         /**
+          * Represents the year field.
+          */
+         YEAR_FIELD(DateFormat.YEAR_FIELD, ChronoField.YEAR),
+         
+         /**
+          * Represents the day of week field.
+          */
+         DAY_OF_WEEK_FIELD(DateFormat.DAY_OF_WEEK_FIELD, ChronoField.DAY_OF_WEEK),
+         
+         /**
+          * Represents the hour field of the zero-based 24-hour clock.
+          */
+         HOUR_OF_DAY0_FIELD(DateFormat.HOUR_OF_DAY0_FIELD, ChronoField.HOUR_OF_DAY),
+         
+         /**
+          * Represents the hour field of the one-based 24-hour clock.
+          */
+         HOUR_OF_DAY1_FIELD(DateFormat.HOUR_OF_DAY1_FIELD, ChronoField.CLOCK_HOUR_OF_DAY),
+         
+         /**
+          * Represents the hour field of the zero-based 12-hour clock.
+          */
+         HOUR0_FIELD(DateFormat.HOUR0_FIELD, ChronoField.HOUR_OF_AMPM),
+         
+         /**
+          * Represents the hour field of the one-based 12-hour clock.
+          */
+         HOUR1_FIELD(DateFormat.HOUR1_FIELD, ChronoField.CLOCK_HOUR_OF_AMPM),
+         
+         /**
+          * Represents the AM/PM field of a 12-hour clock.
+          */
+         AM_PM_FIELD(DateFormat.AM_PM_FIELD, ChronoField.AMPM_OF_DAY),
+         
+         /**
+          * Represents the minute field.
+          */
+         MINUTE_FIELD(DateFormat.MINUTE_FIELD, ChronoField.MINUTE_OF_HOUR),
+         
+         /**
+          * Represents the second field.
+          */
+         SECOND_FIELD(DateFormat.SECOND_FIELD, ChronoField.SECOND_OF_MINUTE);
+         
+         /** DateFormat fields used to display date and time */
+         private final int dateFormat;
+         
+         /** ChronoField used to display date and time */
+         private final ChronoField chronoField;
+         
+         /**
+          * Constructs this enum member with the given pair of DateFormat and ChronoField fields.
+          * 
+          * @param    dateFormat
+          *           The given DateFormat field
+          * @param    chronoField
+          *           The given ChronoField field
+          */
+         private DateTimeField(int dateFormat, ChronoField chronoField)
+         {
+            this.dateFormat = dateFormat;
+            this.chronoField = chronoField;
+         }
+         
+         /**
+          * Returns the DateFormat constant corresponding to this enum member.
+          * 
+          * @return   The corresponding DateFormat constant
+          */
+         public int getDateFormat()
+         {
+            return dateFormat;
+         }
+         
+         /**
+          * Returns the ChronoField member corresponding to this enum member.
+          * 
+          * @return   The corresponding ChronoField member.
+          */
+         public ChronoField getChronoField()
+         {
+            return chronoField;
+         }
+      }
+   }
+}

